package ru.dbotthepony.mc.otm.compat.vanilla

import net.minecraft.world.Container
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import net.minecraft.world.inventory.MenuType
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.menu.MatteryMenuSlot
import ru.dbotthepony.mc.otm.menu.QuickMoveInput
import ru.dbotthepony.mc.otm.menu.SortInput

abstract class AbstractVanillaChestMenu(
	type: MenuType<*>,
	containerId: Int,
	inventory: Inventory,
	val container: Container
) : MatteryMenu(type, containerId, inventory) {
	abstract val rows: Int
	abstract val columns: Int

	abstract val containerSlots: List<MatteryMenuSlot>
	abstract val quickMoveToStorage: Map<QuickMoveInput.Mode, QuickMoveInput>
	abstract val quickMoveFromStorage: Map<QuickMoveInput.Mode, QuickMoveInput>
	val sort = SortInput(this, container, playerSortSettings)

	override fun stillValid(player: Player): Boolean {
		return container.stillValid(player)
	}

	override fun removed(player: Player) {
		super.removed(player)
		container.stopOpen(player)
	}
}
